const app = getApp()
Page({
  onLoad(query) {
    const _that = this;
    dd.setNavigationBar({title: ''});
    //判断有无网络，判断是否离线
    dd.showLoading({
      content: '加载中...',
    });
    dd.getNetworkType({
      success: (res) => {
        // 有网络状态
        if (res.networkAvailable) {
          // 获取免登授权码
          dd.getAuthCode({
            success:function(res){
              // 根据免登授权码获取用户信息
              _that.getUserMsg(res.authCode)
            },
            // 获取免登授权码失败
            fail:function(err){
              console.log(err)
            }
          });
        } 
        // 无网络状态
        else {
          if (dd.getStorageSync({ key: 'token' }).data.access_token) {
            dd.redirectTo({
              url: '/pages/index/index'
            })
          } 
          else {
            dd.alert({
              content: '登录超时，请连接网络重新登录',
              buttonText: '确定'
            });
            dd.hideLoading()
          }
        }
      }
    });    
  },
  // 根据免登授权码获取用户的信息并进行全局存储
  getUserMsg(code) {
    const _that = this;
    let orgId = dd.corpId;

    dd.httpRequest({
      headers: {
        "Content-Type": "application/x-www-form-urlencoded"
      },
      url: `${app.globalData.globalUrl}/mingpay-phone/v1/skipAuth/getUserInfoByCode?code=${code}&orgId=${orgId}`,
      method: 'POST',
      dataType: 'json',
      success: function(res) {
        console.log(res,res)
        if(res.data.resultCode == 0) {
          const data = res.data.data
           dd.setStorageSync({
              key: 'mingUserId',
              data: data.mingUserId
           })
           dd.setStorageSync({
              key: 'userId',
              data: data.oapiUser.userid
           })
           dd.setStorageSync({
              key: 'avatar',
              data: data.oapiUser.avatar
           })
           _that.getUserToken(data.mingUserId)
        }
        else {
          dd.alert({
            content: '系统繁忙',
            buttonText: '确定'
          })
          dd.hideLoading()
        }
      },
      fail: function(res) {
        console.log('err',res.errorMessage)
        if(res.errorMessage == "NETWORK ERROR") {
          dd.alert({
            content:'网络异常，稍后再试',
            buttonText: '确定'
          })
        }
        else {
          dd.alert({
            content:'系统繁忙',
            buttonText:'确定'
          })
        }
        dd.hideLoading();
      }
     
    })
  },
  // 获取token接口
  getUserToken(mingUserId) {
      dd.httpRequest({
             headers: {
               'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: {
               username: mingUserId,
               password: mingUserId,
               scope: 'server',
               grant_type: 'password'
             },
             url:`${app.globalData.globalUrl}/auth/oauth/token`,
             method: 'POST',
             dataType: 'json',
             success: function(res) {
               dd.setStorageSync({
                 key: 'token',
                 data: {
                   access_token: res.data.access_token,
                   expires_in: res.data.expires_in,
                   refresh_token: res.data.refresh_token,
                   loginTime: (new Date()).getTime()
                 }
               })
               dd.hideLoading()
               dd.redirectTo({
                 url: '/pages/index/index'
               })
             },
             fail: function(res) {
               console.log('err',res)
               dd.alert({
                 content: '系统繁忙',
                 buttonText: '确定'
               })
               dd.hideLoading()
             }

           })
  },

  // 有网络的状态更新用户userId和token
  // getUserMsg(code) {
  //   const _that = this;
  //   let token = dd.getStorageSync({ key: 'token' }).data ? dd.getStorageSync({ key: 'token' }).data.access_token : '';
  //   let orgId = dd.corpId;
  //   dd.httpRequest({
  //     headers: {
  //       "Content-Type": "application/json",
  //       "Authorization": `Bearer ${token}`
  //     },
  //     url: `https://${app.globalData.globalUrl}/v1/auth/userToken?version=v1&code=${code}&token=${token}&orgId=${orgId}`,
  //     method: 'POST',
  //     dataType: 'json',
  //     success: function(res) {
  //       console.log(res)
  //       // 全局存储用户信息token和用户信息
  //       if(res.data.resultCode === '0'){
  //         const data = res.data.data;
  //         // 更新用户内部信息
  //         dd.setStorageSync({
  //           key: 'token',
  //           data: {
  //             access_token: data.accessToken.access_token,
  //             token_type: data.accessToken.token_type,
  //             expires_in: data.accessToken.expires_in,
  //             loginTime: (new Date()).getTime()
  //           }
  //         });
  //         dd.setStorageSync({
  //           key: 'userId',
  //           data: data.oapiUser.userid
  //         });
  //         dd.setStorageSync({
  //           key: 'avatar',
  //           data: data.oapiUser.avatar
  //         });
  //         dd.hideLoading();
  //         dd.redirectTo({
  //           url: '/pages/index/index'
  //         })
  //       }else{
  //         dd.hideLoading();
  //         dd.redirectTo({
  //           url: '/pages/noPermission/noPermission'
  //         })
  //       }  
  //     },
  //     fail: function(res) {
  //       console.log('err',res)
  //       dd.alert({
  //         content: '系统繁忙',
  //         buttonText: '确定'
  //       });
  //       dd.hideLoading();
  //     }
  //   });
  // },

  onReady() {
    // 页面加载完成
  },
  onShow() {
    // 页面显示
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
